/* This software is Copyright 1995 by Karl-Johan Johnsson
 *
 * Permission is hereby granted to copy, reproduce, redistribute or otherwise
 * use this software as long as: there is no monetary profit gained
 * specifically from the use or reproduction of this software, it is not
 * sold, rented, traded or otherwise marketed, and this copyright notice is
 * included prominently in any copy made. 
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. ANY USE OF THIS
 * SOFTWARE IS AT THE USER'S OWN RISK.
 */
#ifndef _MessageP_h
#define _MessageP_h

#include "Message.h"
#include <X11/CoreP.h>

typedef struct {
    XtPointer	extension;
} MessageClassPart;

typedef struct _MessageClassRec {
    CoreClassPart	core_class;
    MessageClassPart	message_class;
} MessageClassRec;

extern MessageClassRec messageClassRec;

typedef struct {
    Pixel		foreground_pixel;
    XFontStruct		*font;
    String		buffer;
    Cardinal		buffer_len;
    Dimension		internal_height;
    Dimension		internal_width;
    Dimension		pref_chars;
    Boolean		center;
    /* private data */
    Cardinal		rows;
    GC			default_gc;
} MessagePart;

typedef struct _MessageRec {
    CorePart	core;
    MessagePart	message;
} MessageRec;

#endif /* _MessageP_h */
