/*  This is the command used to send mail (via popen(3)). This should be a
 *  non-interactive command that reads an rfc822 format message from standard,
 *  input, adds the necessary headers (Date, Message-ID, etc...) and dispatches
 *  it according to the Cc: and To: headers.
 *
 *  You'll probably want to leave this as sendmail, but make sure the path
 *  is right.  If you don't have sendmail, use /bin/false :-).
 */
#define MAIL_COMMAND "/usr/lib/sendmail -t"


/*  This macro controls the generation of email addresses.
 *
 *  If DOMAIN_NAME is defined (to a string), then:
 *    a.  If it begins with '/', it is taken as a file containing the
 *        domain name.  This is the preferred way.
 *    b   Otherwise it is taken as the domain name. (Don't do this
 *        unless really necessary.)
 *
 *  If DOMAIN_NAME is not defined, we try gethostbyaddr(gethostname) +
 *  aliases.  If that doesn't work, posting will not be allowed.
 */
/*#define DOMAIN_NAME "/your/file/here"  */
/*#define DOMAIN_NAME "your_domain_here" */


/*  This is the deafult editor.  This can be overridden with X resources,
 *  so you need not change this here.
 *
 *  %s   is the name of the file to edit, and
 *  %i   is the line where the cursor will initially be positioned.
 *
 *  Both %s and %i are optional, although the editor will not be much use
 *  if you don't specify %s...
 */
#define DEFAULT_EDIT_COMMAND "xterm -e vi +%i %s"


/*  The default NNTPSERVER.  Basically: don't set this, use $NNTPSERVER
 *  or the resource Knews.nntpServer instead.
 */
/*#define DEFAULT_NNTPSERVER "your.server"*/
