/* This software is Copyright 1995 by Karl-Johan Johnsson
 *
 * Permission is hereby granted to copy, reproduce, redistribute or otherwise
 * use this software as long as: there is no monetary profit gained
 * specifically from the use or reproduction of this software, it is not
 * sold, rented, traded or otherwise marketed, and this copyright notice is
 * included prominently in any copy made. 
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. ANY USE OF THIS
 * SOFTWARE IS AT THE USER'S OWN RISK.
 */
#ifndef _GroupObjeP_h
#define _GroupObjeP_h

#include "GroupObjec.h"
#include <X11/ObjectP.h>

typedef struct {
    XtPointer	empty;
} GroupObjectClassPart;

typedef struct _GroupObjectClass {
    ObjectClassPart		object_class;
    GroupObjectClassPart	group_object_part;
} GroupObjectClassRec;

extern GroupObjectClassRec	groupObjectClassRec;

typedef struct {
    String	*header_format;
    String	quote_regexp;
    String	quote_string;
    String	attribution;
    String	full_name;
    String	signature_file;
    String	organization;
    String	reply_to;
    String	extra_headers;
    String	uu_dir;
    String	uu_program;
    Pixel	default_hot_pixel;
    KeepType	keep_thread_info;
    Boolean	full_header;
    Boolean	process_xrefs;
    Boolean	show_number_lines;
    Boolean	only_unread;
    Boolean	fixed_author;
    /* private */
    regex_t	*comp_quote_re;
} GroupObjectPart;

typedef struct _GroupObjectRec {
    ObjectPart		object;
    GroupObjectPart	group_object;
} GroupObjectRec;

#endif /* _GroupObjeP_h */
