/* This software is Copyright 1995 by Karl-Johan Johnsson
 *
 * Permission is hereby granted to copy, reproduce, redistribute or otherwise
 * use this software as long as: there is no monetary profit gained
 * specifically from the use or reproduction of this software, it is not
 * sold, rented, traded or otherwise marketed, and this copyright notice is
 * included prominently in any copy made. 
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. ANY USE OF THIS
 * SOFTWARE IS AT THE USER'S OWN RISK.
 */
#ifndef _GroupObjec_h
#define _GroupObjec_h

#include <sys/types.h>
#include <regex.h>

#ifndef XtCHeaderFormat
#define XtCHeaderFormat "HeaderFormat"
#endif
#ifndef XtCQuoteRegexp
#define XtCQuoteRegexp "QuoteRegexp"
#endif
#ifndef XtCQuoteString
#define XtCQuoteString "QuoteString"
#endif
#ifndef XtCAttribution
#define XtCAttribution "Attribution"
#endif
#ifndef XtCFullName
#define XtCFullName "FullName"
#endif
#ifndef XtCSignatureFile
#define XtCSignatureFile "SignatureFile"
#endif
#ifndef XtCOrganization
#define XtCOrganization "Organization"
#endif
#ifndef XtCReplyTo
#define XtCReplyTo "ReplyTo"
#endif
#ifndef XtCUuDir
#define XtCUuDir "UuDir"
#endif
#ifndef XtCUuProgram
#define XtCUuProgram "UuProgram"
#endif
#ifndef XtCExtraHeaders
#define XtCExtraHeaders "ExtraHeaders"
#endif
#ifndef XtCFullHeader
#define XtCFullHeader "FullHeader"
#endif
#ifndef XtCProcessXrefs
#define XtCProcessXrefs "ProcessXrefs"
#endif
#ifndef XtCShowNumberLines
#define XtCShowNumberLines "ShowNumberLines"
#endif
#ifndef XtCOnlyUnread
#define XtCOnlyUnread "OnlyUnread"
#endif
#ifndef XtCKeepThreadInfo
#define XtCKeepThreadInfo "KeepThreadInfo"
#endif
#ifndef XtCFixedAuthor
#define XtCFixedAuthor "FixedAuthor"
#endif

#ifndef XtNheaderFormat
#define XtNheaderFormat "headerFormat"
#endif
#ifndef XtNquoteRegexp
#define XtNquoteRegexp "quoteRegexp"
#endif
#ifndef XtNquoteString
#define XtNquoteString "quoteString"
#endif
#ifndef XtNfullName
#define XtNfullName "fullName"
#endif
#ifndef XtNattribution
#define XtNattribution "attribution"
#endif
#ifndef XtNsignatureFile
#define XtNsignatureFile "signatureFile"
#endif
#ifndef XtNorganization
#define XtNorganization "organization"
#endif
#ifndef XtNreplyTo
#define XtNreplyTo "replyTo"
#endif
#ifndef XtNextraHeaders
#define XtNextraHeaders "extraHeaders"
#endif
#ifndef XtNuuDir
#define XtNuuDir "uuDir"
#endif
#ifndef XtNuuProgram
#define XtNuuProgram "uuProgram"
#endif
#ifndef XtNdefaultHotColor
#define XtNdefaultHotColor "defaultHotColor"
#endif
#ifndef XtNfullHeader
#define XtNfullHeader "fullHeader"
#endif
#ifndef XtNprocessXrefs
#define XtNprocessXrefs "processXrefs"
#endif
#ifndef XtNshowNumberLines
#define XtNshowNumberLines "showNumberLines"
#endif
#ifndef XtNonlyUnread
#define XtNonlyUnread "onlyUnread"
#endif
#ifndef XtNkeepThreadInfo
#define XtNkeepThreadInfo "keepThreadInfo"
#endif
#ifndef XtNfixedAuthor
#define XtNfixedAuthor "fixedAuthor"
#endif

typedef enum {
    KeepTypeYes,
    KeepTypeNo,
    KeepTypeSubscribed
} KeepType;

typedef struct _GroupObjectClassRec*	GroupObjectClass;
typedef struct _GroupObjectRec*		GroupObject;

extern WidgetClass groupObjectClass;

#ifdef _XFUNCPROTOBEGIN
_XFUNCPROTOBEGIN
#endif

extern GroupObject	GroupObjectCreate(Widget, char*);
extern char	      **GroupObjectHeaderFormat(GroupObject);
extern regex_t	       *GroupObjectQuoteRegexp(GroupObject);
extern char	       *GroupObjectQuoteString(GroupObject);
extern char	       *GroupObjectAttribution(GroupObject);
extern char	       *GroupObjectFullName(GroupObject);
extern char	       *GroupObjectSignatureFile(GroupObject);
extern char	       *GroupObjectOrganization(GroupObject);
extern char	       *GroupObjectReplyTo(GroupObject);
extern char	       *GroupObjectExtraHeaders(GroupObject);
extern char	       *GroupObjectUuDir(GroupObject);
extern char	       *GroupObjectUuProgram(GroupObject);
extern Pixel		GroupObjectDefaultHotPixel(GroupObject);
extern Boolean		GroupObjectFullHeader(GroupObject);
extern Boolean		GroupObjectProcessXrefs(GroupObject);
extern Boolean		GroupObjectShowNumberLines(GroupObject);
extern Boolean		GroupObjectOnlyUnread(GroupObject);
extern KeepType		GroupObjectKeepThreadInfo(GroupObject);
extern Boolean		GroupObjectFixedAuthor(GroupObject);

#ifdef _XFUNCPROTOBEGIN
_XFUNCPROTOEND
#endif

#endif /* _GroupObjec_h */
