/* This software is Copyright 1995 by Karl-Johan Johnsson
 *
 * Permission is hereby granted to copy, reproduce, redistribute or otherwise
 * use this software as long as: there is no monetary profit gained
 * specifically from the use or reproduction of this software, it is not
 * sold, rented, traded or otherwise marketed, and this copyright notice is
 * included prominently in any copy made. 
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. ANY USE OF THIS
 * SOFTWARE IS AT THE USER'S OWN RISK.
 */

/* This could be a subclass of Object, but I want
 * editres to be able to see it's children.
 */

#ifndef _NntpObjecP_h
#define _NntpObjecP_h

#include "NntpObject.h"
#include <X11/CompositeP.h>

typedef struct {
    XtPointer	empty;
} NntpObjectClassPart;

typedef struct _NntpObjectClass {
    CoreClassPart	object_class;
    CompositeClassPart	composite_class;
    NntpObjectClassPart	nntp_object_part;
} NntpObjectClassRec;

extern NntpObjectClassRec	nntpObjectClassRec;

typedef struct {
    String		nntp_server;
    String		newsrc_dir;
    String		newsrc_file;
    String		old_newsrc_file;
    String		kill_dir;
    String		kill_file;
    String		*auto_subscribe;
    String		auth_info_user;
    String		auth_info_pass;
    String		auth_info_generic;
    String		posting_agent;
    int			rescan_timeout;
    Boolean		retrieve_descriptions;
    Boolean		create_newsrc;
    Boolean		check_for_new_groups;
    Boolean		read_active_file;
    Boolean		fill_newsrc_file;
    Boolean		thread_em_all;
} NntpObjectPart;

typedef struct _NntpObjectRec {
    CorePart		object;
    CompositePart	composite;
    NntpObjectPart	nntp_object;
} NntpObjectRec;

#endif /* _NntpObjecP_h */
