/* This software is Copyright 1995 by Karl-Johan Johnsson
 *
 * Permission is hereby granted to copy, reproduce, redistribute or otherwise
 * use this software as long as: there is no monetary profit gained
 * specifically from the use or reproduction of this software, it is not
 * sold, rented, traded or otherwise marketed, and this copyright notice is
 * included prominently in any copy made. 
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. ANY USE OF THIS
 * SOFTWARE IS AT THE USER'S OWN RISK.
 */
#ifndef _NntpObject_h
#define _NntpObject_h

#ifndef XtCNntpServer
#define XtCNntpServer "NntpServer"
#endif
#ifndef XtCNewsrcDir
#define XtCNewsrcDir "NewsrcDir"
#endif
#ifndef XtCNewsrcFile
#define XtCNewsrcFile "NewsrcFile"
#endif
#ifndef XtCOldNewsrcFile
#define XtCOldNewsrcFile "OldNewsrcFile"
#endif
#ifndef XtCKillDir
#define XtCKillDir "KillDir"
#endif
#ifndef XtCKillFile
#define XtCKillFile "KillFile"
#endif
#ifndef XtCAutoSubscribe
#define XtCAutoSubscribe "AutoSubscribe"
#endif
#ifndef XtCAuthInfoUser
#define XtCAuthInfoUser "AuthInfoUser"
#endif
#ifndef XtCAuthInfoPass
#define XtCAuthInfoPass "AuthInfoPass"
#endif
#ifndef XtCAuthInfoGeneric
#define XtCAuthInfoGeneric "AuthInfoGeneric"
#endif
#ifndef XtCPostingAgent
#define XtCPostingAgent "PostingAgent"
#endif
#ifndef XtCRescanTimeout
#define XtCRescanTimeout "RescanTimeout"
#endif
#ifndef XtCRetrieveDescriptions
#define XtCRetrieveDescriptions "RetrieveDescriptions"
#endif
#ifndef XtCCreateNewsrc
#define XtCCreateNewsrc "CreateNewsrc"
#endif
#ifndef XtCCheckForNewGroups
#define XtCCheckForNewGroups "CheckForNewGroups"
#endif
#ifndef XtCReadActiveFile
#define XtCReadActiveFile "ReadActiveFile"
#endif
#ifndef XtCFillNewsrcFile
#define XtCFillNewsrcFile "FillNewsrcFile"
#endif
#ifndef XtCThreadEmAll
#define XtCThreadEmAll "ThreadEmAll"
#endif

#ifndef XtNnntpServer
#define XtNnntpServer "nntpServer"
#endif
#ifndef XtNnewsrcDir
#define XtNnewsrcDir "newsrcDir"
#endif
#ifndef XtNnewsrcFile
#define XtNnewsrcFile "newsrcFile"
#endif
#ifndef XtNoldNewsrcFile
#define XtNoldNewsrcFile "oldNewsrcFile"
#endif
#ifndef XtNkillDir
#define XtNkillDir "killDir"
#endif
#ifndef XtNkillFile
#define XtNkillFile "killFile"
#endif
#ifndef XtNautoSubscribe
#define XtNautoSubscribe "autoSubscribe"
#endif
#ifndef XtNauthInfoUser
#define XtNauthInfoUser "authInfoUser"
#endif
#ifndef XtNauthInfoPass
#define XtNauthInfoPass "authInfoPass"
#endif
#ifndef XtNauthInfoGeneric
#define XtNauthInfoGeneric "authInfoGeneric"
#endif
#ifndef XtNpostingAgent
#define XtNpostingAgent "postingAgent"
#endif
#ifndef XtNrescanTimeout
#define XtNrescanTimeout "rescanTimeout"
#endif
#ifndef XtNretrieveDescriptions
#define XtNretrieveDescriptions "retrieveDescriptions"
#endif
#ifndef XtNcreateNewsrc
#define XtNcreateNewsrc "createNewsrc"
#endif
#ifndef XtNcheckForNewGroups
#define XtNcheckForNewGroups "checkForNewGroups"
#endif
#ifndef XtNreadActiveFile
#define XtNreadActiveFile "readActiveFile"
#endif
#ifndef XtNfillNewsrcFile
#define XtNfillNewsrcFile "fillNewsrcFile"
#endif
#ifndef XtNthreadEmAll
#define XtNthreadEmAll "threadEmAll"
#endif

typedef struct _NntpObjectClassRec*	NntpObjectClass;
typedef struct _NntpObjectRec*		NntpObject;

extern WidgetClass nntpObjectClass;

#ifdef _XFUNCPROTOBEGIN
_XFUNCPROTOBEGIN
#endif

extern NntpObject	NntpObjectCreate(Widget, char* /* nntp_server */);
extern char	       *NntpObjectKillFile(NntpObject);
extern char	       *NntpObjectNewsrcFile(NntpObject);
extern char	       *NntpObjectOldNewsrcFile(NntpObject);
extern char	      **NntpObjectAutoSubscribe(NntpObject);
extern char	       *NntpObjectAuthInfoUser(NntpObject);
extern char	       *NntpObjectAuthInfoPass(NntpObject);
extern char	       *NntpObjectAuthInfoGeneric(NntpObject);
extern char	       *NntpObjectPostingAgent(NntpObject);
extern int		NntpObjectRescanTimeout(NntpObject);
extern Boolean		NntpObjectRetrieveDescriptions(NntpObject);
extern Boolean		NntpObjectCreateNewsrc(NntpObject);
extern Boolean		NntpObjectCheckForNewGroups(NntpObject);
extern Boolean		NntpObjectReadActiveFile(NntpObject);
extern Boolean		NntpObjectFillNewsrcFile(NntpObject);
extern Boolean		NntpObjectThreadEmAll(NntpObject);

#ifdef _XFUNCPROTOBEGIN
_XFUNCPROTOEND
#endif

#endif /* _NntpObject_h */
