.TH KNEWS 1 "26 Juli 1995"
.SH NAME
knews \- Karl's threaded newsreader for X
.SH SYNOPSIS
.B knews
[ options ]
.SH DESCRIPTION
Knews is a threaded newsreader with an X Window interface that uses
NNTP to get news. This manual is intended to explain things that are not
apparent from the interface, so if you just want to get started, you
probably don't need to read this.
.SH OPTIONS
In addtiion to the standard X Toolkit options knews accepts the
following options, which set various X resources.  For an explanation
of what the resources do, se the section on resources.  You don't have
to type out the entire name of the option, as long as it is unique.

.B -nntpserver hostname
.RS
Sets the resource 'Knews.nntpServer' to 'hostname'.
.RE

.B +/-bell
.RS
Sets the resource 'Knews.bell' to True/False.
.RE

.B +/-active
.RS
Sets the resource '*readActiveFile' to True/False.
.RE

.B +/-descriptions
.RS
Sets the resource '*retrieveDescriptions' to True/False.
.RE

.B +/-fill
.RS
Sets the resource '*fillNewsrc' to True/False.
.RE

.B +/-separate
.RS
Sets the resource 'Knews.separateWindows' to True/False.
.RE

.SH "THE THREAD TREE"
The articles in a thread are displayed as nodes in a tree. A border inside
a node indicates that the article is unread, a border outside a node
indicates that the article is 'tagged', and a dashed branch in the tree
indicates a change of subject. By default, you can scroll around in the
tree with the middle mouse button. An empty box in the tree indicates
a 'fake' article, i.e. one that has expired on the server, has not yet
arrived or was posted in a different newsgroup.

.SH "TAGGING ARTICLES"
Articles in the thread tree can be tagged with the third mouse button.
Clicking on a subject with the third mouse button causes the unread articles
in that thread to be tagged in preorder (depth first). Once you have
tagged the articles, you can mark then read/unread, save or pipe them in
order, and so on.

.SH "DRAG AND DROP"
The all groups list and the kill list can be reorderd by drag'n'drop.
The default translation is the second mouse button.

.SH ABORT
You may abort the interaction with the NNTP server at any time. This
causes the connection to be closed, and a new one to be opened. Note
that this puts a certain load on the server.

.SH "THREAD AHEAD"
Knews is capable of threading groups in the background while you are
e.g. reading another group.  To do this you click on one or more groups
in the group list with the right mouse button.  Knews then opens a second
connection to the server and uses it to thread the selected groups.  The
status of the thread ahead is shown in the group list as a character:

.nf
-	The group is scheduled for thread ahead.
*	The group is being threaded.
+	The group has been threaded.
.fi

.SH "REGULAR EXPRESSIONS"
The regular expressions used by knews are case insensitive POSIX.2
extended regular expressions, similar to those used by egrep(1).
Note that these are not anchored by default, so that e.g. the
expression 'alt' will match any string containing the three
character sequence 'alt'.

.SH SEARCHING
Article heads and bodies may be searched for regular expressions.
Searching applies only to unread articles, and starts with the 'next'
article. The newsgroup list may also be searched.

It is also possible to use XPAT searching, if the nntp server supports
it.  To do this, you fill in the 'Header' field on the search popup
with the header you're interested in (e.g. 'Content-Type') and the
wildcard field with a wildcard expression.  Pressing 'Submit' then
sends this to the server, and after a while it responds with a list
of matching articles.  You can then move between those articles with
the 'Next' and 'First' buttons on the search popup.

.SH "SAVING AND PIPING"
The save/pipe popup and the save/pipe action procedures understand ~
filenames and expands the following %'s:

.nf
%%	%
%n	The name of the current group.
%N	The name of the current group, capitalized.
%g	The name of the current group, slashed.
%G	The name of the current group, capitalized and slashed.
.fi

Slashed means that the dots are replaced with slashes.

.SH "THE KILL FILE"
The kill file may be used to 'kill' (mark read) or 'hot' (mark interesting)
articles, subjects and threads based on different cirteria. Each line in the
kill file specifies an entry according to the following syntax:

.nf
(F)(S)(T)[Col] || Group regexp || Field expression
.fi

.B (F)
.RS
This is a character specifying to which header this entry applies.
Legal values are:

.nf
\'M'     The 'Message-ID:' header.
\'S'     The 'Subject:' header.
\'F'     The 'From:' header.
\'X'     The 'Xref:' header.
.fi

Note that 'X' only works if the 'Xref:' header is included in the
overview files from the server. Also note that the 'Re: ' prefix
is not considered part of the subject.
.RE

.B (S)
.RS
This is a character specifying the scope of the entry, i.e. what articles
are killed/'hotted' when this entry applies to an article. Legal values
are:

.nf
\'A'     This article.
\'S'     All articles with the same subject.
\'T'     The entire thread.
\'t'     The subthread starting with this article.
.fi
.RE

.B (T)
.RS
This is either 'K' or 'H' for kill and 'hot' respectively.

.B [col]
.RS
In 'hot' entries, this is the color used to mark the relevant
articles with.
.RE
.RE

.B ||
.RS
This two character sequence is used as a separator.
.RE

.B Group regexp
.RS
Only newsgroups matching this regular expression will be
affected by this entry.
.RE

.B Field expression
.RS
If the header field is 'S', 'F' or 'X', this is a regular expression,
and the entry applies to all matching articles. If the header field
is 'M', this is a message id; this id is probably the fastest type of
kill entry, since it can be checked with a single hash lookup.
.RE

To see what articles were killed: when you have read all unread articles,
or marked them read, use the 'mark unread, killed' feature on the
misc menu.

.SH "MIME VIEWERS"

Knews has internal support for content-types text/plain, message/rfc822,
multipart/mixed, and multipart/digest.  Any other subtype of multipart
is treated as mixed.  Quoted printable and base64 encodings are handled.
For a given type/subtype, knews tries to find an external 'viewer' by
retrieving the value of the following resources:

.nf
.B Knews.mime.type.subtype
.B Knews.mime.type
.fi

There are two exceptions: If the content type is text/subtype, knews first
checks the resource

.nf
.B Knews.mime.text.subtype.charset
.fi

where 'charset' is the value of the charset parameter. This will let you
specify external viewers for specific charsets.

If the content type is message/external-body, the resource

.nf
.B Knews.mime.message.external-body.access-type
.fi

is used, where 'access-type' is the value of the access-type. This will
let you specify external viewers for specific access-types, e.g. anon-ftp.

If no viewer is found according to the above scheme and the type
is not one of text/*, message/* and multipart/*, knews uses an
internal 'viewer' that lets the user save the mime body to a
file or pipe it to a shell command.

In the view-command, the following % expansions are performed:

.RS
.B %%
.RS
This is replaced with the character %.
.RE

.B %t
.RS
This is replaced with type/subtype.
.RE

.nf
.B %{param}
.B %[param]
.B %(param)
.fi
.RS
Each of these is replaced with the value of the parameter 'param'.
If that parameter is not present, they behave differently: %{ means
that the viewer is not used, %[ is replaced by nothing, and %(
is replaced with the two characters '' (which may be good, since
the view-command is expanded by the shell).
.RE

.B %s
.RS
This is replaced with the name of a temporary file containing the body 
of the relevant mime-entity.  It is then the responsibility of the
viewer to unlink this file.
.RE
.RE

If no %s is specified, the viewers stdin is 'linked' to a temporary
file which is immediately deleted.

.SH "READING THE SPOOLDIR"
Knews supports a rather obscure mechanism for communicating with an
arbitrary program instead of an nntp server.  Using knewsd(1), this
can be used for reading news (in)directly from the spool dir, or even
mail folders if they are in the correct format.  This is how it works:
If the nntp server is given as #str, where str is an arbitrary string
not containing white space or the characters '/', '.' or '*', knews
finds the value of the resource
.B Knews.#str
and tries to execute that program.  The program has it's standard input
and output connected to knews.  If you use this resourse setting:

.nf
Knews.#1: knewsd -spool /var/spool/news \\
	-active /usr/local/news/active
.fi

with the apropriate paths for your system, you can read the spool
directory by specifying the nntp server as '#1' in e.g. the connect
dialogue.  This could easily be used to read mh(1) style mail folders
too.

.SH "X RESOURCES"
There are a number of X resources that affect the behaviour and
appearance of knews.   Most widgets in the widget hierarchy has
resources named
.B background
,
.B foreground
,
.B shadowWidth
, and so on. For more information see the application defaults
file Knews.ad included in the distribution. To get a feeling for
resources, try editres(1).

.B Knews.nntpServer
.RS
If this resource is set, knews automatically connects to this
nntp server on startup. This overrides the NNTPSERVER environment
variable. If the server listens to a non-standard port, you may
specify this e.g as foo.bar:1234. If you don't want knews to
autoconnect, don't set this or $NNTPSERVER.
.RE

.B Knews.editCommand
.RS
This resource specifies the editor used to edit posts. Possible
values include:

.nf
Knews.editCommand:  xemacs +%i %s
Knews.editCommand:  emacs +%i %s
Knews.editCommand:  xterm -e vi +%i %s
.fi

%s stands for the name of a temporary file, and %i for the line
where editing should begin. The default value of this resource
is a compile time option.
.RE

.B Knews.bell
.RS
Setting this resource to False will turn of the bell.
.RE

.B Knews.separateWindows
.RS
Setting this resource to True will make knews use a different
top level window for the article text widget.
.RE

.B Knews.stderrTimeout
.RS
When knews starts a pipe or similar, it captures the standard
error output and displays it in a notice popup.  This resource
is the time in milliseconds this popup should stay up.  The
default is 3000.  Setting this to 0 means stay up indefinitely,
and negative means no popups.
.RE

.B Knews.aheadTimeout
.RS
The amout of time the second connection used for 'thread ahead' is
allowed to be idle before it is closed.  The default is 30000, i.e.
30 seconds.
.RE

.B Knews.mailName
.RS
If you have a mail address which isn't of the form 'userid@domain.name',
you can set this to the part of the address that goes before the '@',
e.g.

.nf
Knews.mailName:		FirstName.LastName
.fi

Note that your userid will still be used for the 'Sender' header if
necessary.
.RE


The following resources can be used to change various color,
font and geometry settings:

.nf
.B Knews*grouplist.preferredLines
.B Knews*grouplist.preferredColumns
.fi
.RS
This resource specifies the number of lines and columns the
grouplist widget will start up with. The default is 14 for
lines and 84 for columns.
.RE

.nf
.B Knews*text.preferredLines
.B Knews*text.preferredColumns
.fi
.RS
This resource specifies the number of lines and columns the
article text widget start up with. The default is 32 for
lines and 84 for columns.
.RE

.B Knews*rubberColor
.RS
The color used for rubberbanding in one or two widgets.
The default is red.
.RE

.nf
.B Knews*quoteColor
.B Knews*quoteFont
.fi
.RS
The color and font used for quoted lines in the article window.
.RE

.nf
.B Knews*headerColor
.B Knews*headerFont
.fi
.RS
The color and font used for header lines in the article window
.RE

.nf
.B Knews*innerColor
.B Knews*innerDashed
.fi
.RS
The color and line style used for the border of unread articles in
the article tree. The defaults are Red and False.
.RE

.nf
.B Knews*outerColor
.B Knews*outerDashed
.fi
.RS
The color and line style used for the border of tagged articles in
the article tree. The defaults are foreground and False.
.RE

.B Knews*ScrList.font
.RS
The font used in the lists.
.RE


When knews connects to an NNTP server, call it foo.bar for the
sake of argument, it creates a widget of class NntpObject with
name foo_bar. This widgets then has the following resources:

.B Knews.foo_bar.postingAgent
.RS
If this is specified, knews will use this for posting, instead
of posting via NNTP.  If your server requires some kind of
authentication that only inews understands, you could set this
to inews -h.  Note that inews appends the signature, so you
don't want knews to add one too.
.RE

.nf
.B Knews.foo_bar.authInfoPass
.B Knews.foo_bar.authInfoUser
.fi
.RS
These resources are used to implement the NNTP AUTHINFO USER/PASS
protocol if required by the server. Note that setting these in
your .Xdefaults file or similar will make them visible to anyone
with access to your display.
.RE

.B Knews.foo_bar.authInfoGeneric
.RS
This resource is used to implement the NNTP AUTHINFO GENERIC
protocol if required by the server. This will not be tried if the
resources authInfoUser and authInfoPass are set. I have not had the
opportunity to test this, so I'd appreciate any input. The default
is the value of the environment variable NNTPAUTH.
.RE

.B Knews.foo_bar.autoSubscribe
.RS
This is a space separated list of newsgroups to which the
user will be automatically subscribed when (s)he connects
to an NNTP server for which there is no corresponding newsrc
file. The default is 'news.answers news.announce.newusers'.
.RE

.B Knews.foo_bar.checkForNewGroups
.RS
This is a boolean resource indicating whether to check for
new groups when connecting to this server. The default is 'True'.
.RE

.B Knews.foo_bar.createNewsrc
.RS
This is a boolean resource indicating whether to create a
new newsrc file when connecting to a server for which there
is no corresponding newsrc file. The default is 'True'.
.RE

.nf
.B Knews.foo_bar.killDir
.B Knews.foo_bar.newsrcDir
.fi
.RS
Relative kill file names and newsrc file names are considered
relative to these directories. The default for both is $HOME.
If you don't like all those dot-files, you could set these e.g.
to News.
.RE

.nf
.B Knews.foo_bar.killFile
.B Knews.foo_bar.newsrcFile
.B Knews.foo_bar.oldNewsrcFile
.fi
.RS
This specifies the kill file, newsrc file and oldnewsrc file for the
server foo.bar. The defaults are dynamically constructed based on the
name of the NNTP server; in the case of foo.bar they
are '.kill-foo.bar', '.newsrc-foo.bar' and '.oldnewsrc-foo.bar'.
The last modification date of the oldnewsrc file is used to check for
new groups.
.RE

.B Knews.foo_bar.rescanTimeout
.RS
This indicates the time in minutes between automatic rescans.
The default is 60 minutes, 0 means no automatic rescans.
Regardless of this, rescans will only be performed at special
points, to prevent an 'rescan-idle-rescan' loop.
.RE

.B Knews.foo_bar.retrieveDescriptions
.RS
A boolean resource indicating whether to retrieve newsgroup
descriptions from the server. The default is 'True'; setting
this to 'False' may slightly speed up connection time.
.RE

.B Knews.foo_bar.readActiveFile
.RS
Setting this to False will stop knews from reading the active
file when connecting, using the groups in the newsrc file instead.
This will speed up connection on slow lines if you don't have too
many subscribed groups.  The default is True.
.RE

.B Knews.foo_bar.fillNewsrcFile
.RS
Setting this to True will make knews write all groups it knows
about to the newsrc file, which may be a good idea if the option
readActiveFile is set to False.  The default is False, which means
only put information in the newsrc file.
.RE

.B Knews.foo_bar.threadEmAll
.RS
Setting this boolean resource to true will make knews schedule all
subscribed groups for `thread ahead` when connecting to the server.
.RE


When you are connected to foo.bar, and enter a newsgroup,
e.g. comp.windows.x, knews creates a widget of class GroupObject
with name comp_windows_x, as a child of the above mentioned
NntpObject. This widget has the following resources which
control the behaviour of knews:

.B Knews.foo_bar.comp_windows_x.attribution
.RS
This string is used to attribute quotations when you post
a followup. The default is 'In article %m,\\n\\t%f writes:',
where %m stands for the 'Message-ID:', and %f for the 'From:'
header content of the article you are following up to.
.RE

.B Knews.foo_bar.comp_windows_x.defaultHotColor
.RS
This color is used for 'hot' entries in the kill file when
the specified color cannot be allocated for some reason, e.g.
it is invalid or the colormap is full. The default is
the foreground color.
.RE

.B Knews.foo_bar.comp_windows_x.extraHeaders
.RS
This string is inserted into the head of all articles you
post (before editing...). The default is empty.
.RE

.B Knews.foo_bar.comp_windows_x.fixedAuthor
.RS
Setting this to True will stop knews from changing the author displayed
in the subject list to the author of the first unread article.
.RE

.B Knews.foo_bar.comp_windows_x.fullHeader
.RS
A boolean specifying whether to show all headers in the article
window. It also means turn off all MIME transformations. The
default is 'False'.
.RE

.B Knews.foo_bar.comp_windows_x.fullName
.RS
This is the full name used in the 'From:' header in the articles
you post. The default is $NAME, if set, otherwise the gecos field
from the password file.
.RE

.B Knews.foo_bar.comp_windows_x.headerFormat
.RS
A colon separated list specifying which headers to show in the
article window, and in what order. The default
is 'Subject:Newsgroups:Followup-To:Reply-To:Content-Description:Date:Organization:From:'.
.RE

.B Knews.foo_bar.comp_windows_x.organization
.RS
A string used to construct the 'Organization:' header in the
articles you post. The default is $NEWSORG if set, otherwise
$ORGANIZATION if set, otherwise nothing.
.RE

.B Knews.foo_bar.comp_windows_x.processXrefs
.RS
If this boolean is True, as it is by default, articles that are
crossposted will be marked read in all groups when you read them,
mark them read, kill them or catch them up.
Note that this only applies to subscribed groups, and will only
work if the server's overview file contains the Xref: headers.
.RE

.B Knews.foo_bar.comp_windows_x.quoteRegexp
.RS
Lines in an article matching this regular expression will be
considered quoted lines, and may be marked with a different color
and font. The default is '^[>:]'. You will probably want to have
this expression anchored...
.RE

.B Knews.foo_bar.comp_windows_x.quoteString
.RS
This string is used to quote when you are posting a followup.
The default is '>'.
.RE

.B Knews.foo_bar.comp_windows_x.replyTo
.RS
A string used to construct the 'Reply-To:' header in the articles
you post. The default is the value of the environment variable
REPLYTO, if set.
.RE

.B Knews.foo_bar.comp_windows_x.showNumberLines
.RS
A boolean resource indicating whether to show the number of lines
in articles in the thread tree.  The default is False.
.RE

.B Knews.foo_bar.comp_windows_x.signatureFile
.RS
The contents of this file will be used to sign the articles you
post (before editing). The default is $HOME/.signature.
.RE

.B Knews.foo_bar.comp_windows_x.keepThreadInfo
.RS
This resource tells knews whether to keep thread information in memory
after the group is exited.  This will make reentering the group fast.
Legal values are: 'true'/'yes', 'subscribed' and 'false'/'no'. 'subscribed'
means only do it if the group is subscrived, and exists to allow settings
such as:
.nf
Knews*keepThreadInfo:	subscribed
.fi
to keep thread info for all subscribed groups.
.RE

.B Knews.foo_bar.comp_windows_x.uuDir
.RS
Uudecoded files will end up in this directory.
.RE

.B Knews.foo_bar.comp_windows_x.uuProgram
.RS
This program will be used to uudecode files: it will be given the
bodies of the relevant articles on standard input.  The default
is NULL, which means that knews will do it's best to filter out
garbage and then pipe the rest to 'uudecode'.
.RE

.SH ACTIONS
Knews defines a number of actions that can be tied to keys and buttons
via translations.  For the default translations, see the application
defaults file.

.nf
.B tree-up(arg)
.B tree-down(arg)
.B tree-left(arg)
.B tree-right(arg)
.B tree-down-right(arg)
.fi
.RS
These move around in the thread tree. If the arg is 'read', they will
also read in the relevant article, if arg is 'fake', they will also try
to read 'fake' articles.
.RE

.nf
.B list-up(arg)
.B list-down(arg)
.fi
.RS
These move up and down in the lists. If arg is given, it is the number
of steps.
.RE

.nf
.B enter-mode()
.B exit-mode()
.fi
.RS
These two actions moves between modes.
.RE

.nf
.B tree-or-list-up(arg)
.B tree-or-list-down(arg)
.B tree-left-or-exit-mode(arg)
.B tree-right-or-enter-mode(arg)
.fi
.RS
These are combination actions.  E.g. tree-or-list-up(arg) does tree-up or
list-up(1), depending on which is relevant.
.RE

.B read-article(arg)
.RS
This rereads the current article. If arg is given, the article is displayed
with full header and no MIME transformations.
.RE

.B view-thread(arg)
.RS
This moves between the subject list and the thread tree. If arg is 'toggle',
it toggles, if arg is 'yes' it goes to the tree, and if arg is 'no', it goes
to the subject list.
.RE

.nf
.B followup(arg)
.B reply(arg)
.B followup-and-reply(arg)
.B post-new()
.fi
.RS
These correspond to the options on the post menu. If arg is given as 'yes'
or 'no', it indicates whether to include quoted text.
.RE

.nf
.B uudecode
.B clear-tagged()
.B mark-read-article()
.B mark-read-subject()
.B mark-read-thread()
.B mark-read-subthread()
.B mark-read-to-current()
.B mark-read-all()
.B mark-read-tagged()
.B mark-unread-article()
.B mark-unread-subject()
.B mark-unread-thread()
.B mark-unread-subthread()
.B mark-unread-all()
.B mark-unread-tagged()
.B mark-unread-killed()
.fi
.RS
These perform the corresponding functions on the misc menu.
.RE

.nf
.B pipe(command, parts [, scope])
.B save(filename, parts [, scope])
.fi
.RS
Pipe and save actions.  The argument 'parts' is a combination of the
characters 'f', 's', 'h', 'b', 'e', corresponding to the 'bogus
from', 'bogus subject', 'head', 'body' and 'empty line' options on
the save popup window.  The 'scope' parameter is optional, and is
one of 'window', 'article', 'subject', 'thread', 'subthread' and 'tagged',
corresponding to those options on the save popup.
.RE

.nf
.B tag-thread([all])
.B tag-subject([all])
.fi
.RS
These tag the unread articles in a thread or subject.  If 'all' is specified,
they tag all articles is the thread or subject.
.RE

.nf
.B catchup()
.B unsubscribe()
.B subscribe()
.fi
.RS
Guess what.
.RE

.B change-size(pixels)
.RS
Changes the size of the upper portion of the main window by the specified
number of pixels.
.RE

.B schedule-thread-ahead()
.RS
Causes a group to be scheduled for 'thread ahead'.
.RE

.B popup-find-group()
.RS
Popups the 'find group' popup, same as the 'find group' option on the
misc menu.
.RE

.SH WIDGETS
The X interface of knews is built its own widget set plus the Layout
Widget. You are welcome to use it if you like. Unfortunately there
is no documentation.

.SH AUTHOR
This software is Copyright 1995 by Karl-Johan Johnsson
<kjj@matematik.su.se>.

Permission is hereby granted to copy, reproduce, redistribute or otherwise
use this software as long as: there is no monetary profit gained
specifically from the use or reproduction of this software, it is not
sold, rented, traded or otherwise marketed, and this copyright notice is
included prominently in any copy made. 

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. ANY USE OF THIS
SOFTWARE IS AT THE USER'S OWN RISK.

.SH ACKNOWLEDGMENTS

The threading algorithm was adapted from trn. Thanks to Wayne Davison.

Knews uses Keith Packard's Layout Widget.

The distribution includes Henry Spencer's regex package for
environments that do not have POSIX.2 regular expressions.

Thanks to Mattias Jonsson for ardent testing.

Any problems are of course entirely due to me.
.SH "SEE ALSO"
egrep(1), knewsd(1), kuufilter(1), trn(1), uudecode(1), newsrc(5), regex(7)

.SH "KNOWN PROBLEMS"
AUTHINFO GENERIC have not been tested yet.

If the server doesn't support XOVER, threading will be very slow.

The kill file editor may seem a bit eccentric.

The uudecode function may not recognize or correctly handle all cases.

.SH BUGS
Send bug reports and comments to kjj@matematik.su.se.
