/* This software is Copyright 1995 by Karl-Johan Johnsson
 *
 * Permission is hereby granted to copy, reproduce, redistribute or otherwise
 * use this software as long as: there is no monetary profit gained
 * specifically from the use or reproduction of this software, it is not
 * sold, rented, traded or otherwise marketed, and this copyright notice is
 * included prominently in any copy made. 
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. ANY USE OF THIS
 * SOFTWARE IS AT THE USER'S OWN RISK.
 */
#include <sys/types.h>

void *memmove(void *dest, const void *src, size_t n)
{
    char	*cd = dest;
    const char	*cs = src;

    if (cd <= cs)
	while (n-- > 0)
	    *cd++ = *cs++;
    else {
	cd += n - 1;
	cs += n - 1;
	while (n-- > 0)
	    *cd-- = *cs--;
    }

    return dest;
}
